package com.example.bytheway.Activity;

import android.annotation.SuppressLint;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Typeface;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import android.view.WindowManager;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;

import com.example.bytheway.R;
import com.example.bytheway.UrlObject.UrlObject;

import java.io.IOException;

import okhttp3.Call;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;


public class LoginActivity extends AppCompatActivity {
    private Button LoginButton,SignUpButton;
    //    private Button signup_button;
    private CheckBox rememberPass;
    private TextView TitleText;
    private SharedPreferences pref;
    private SharedPreferences.Editor editor;
    private EditText UserNameEdit,PassWordEdit;
    private Button test;//测试用

    private String username_input = ""; // 输入的用户名
    private String password_input = "";// 输入的用户密码
    private static final int REQUEST_CODE_SIGNUP = 0;

    String page_url = UrlObject.url_path + "aslogin";
    String responseData;

    private static final String TAG = "LoginActivity";

    public String id = "";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_login_demo);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
        //获取haredPreferences实例
        pref = PreferenceManager.getDefaultSharedPreferences(this);
        //获取控件实例
        UserNameEdit = (EditText) findViewById(R.id.UserNameEdit);
        PassWordEdit = (EditText) findViewById(R.id.PassWordEdit);
        LoginButton = (Button) findViewById(R.id.LoginButton);
        SignUpButton= (Button) findViewById(R.id.SignUpButton);
        TitleText = (TextView) findViewById(R.id.TitleText) ;
        Typeface typeFace =Typeface.createFromAsset(getAssets(),"fonts/CYJT.ttf");
        TitleText.setTypeface(typeFace);
        String account = pref.getString("Tel", "");
        String password = pref.getString("password", "");
        UserNameEdit.setText(account);
        PassWordEdit.setText(password);
        //对注册监听
        SignUpButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent=new Intent(LoginActivity.this,RegisterActivityOne.class);
                startActivity(intent);
            }
        });
        //对登录按钮设置监听
        LoginButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                username_input = UserNameEdit.getText().toString().trim();
                password_input = PassWordEdit.getText().toString().trim();
                okhttp3.Callback callback = new okhttp3.Callback() {
                    @Override
                    public void onResponse(Call call, Response response) throws IOException {
                        responseData = response.body().string();
                        Log.d(TAG, "服务器返回成功"+responseData);
                        showResponse(responseData);
                    }

                    @Override
                    public void onFailure(Call call, IOException e) {
                        responseData = "Error!";
                        Log.e(TAG, "服务器返回失败");
                        showResponse(responseData);
                    }
                };

                OkHttpClient client = new OkHttpClient();
                //GET请求
                String getURL = page_url + "?Tel=" + username_input + "&Password=" + password_input;
                Request request = new Request.Builder()
                        .url(getURL)
                        .build();
                client.newCall(request).enqueue(callback);


            }

            private void showResponse(final String response) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        Log.w("response",response);
                        String substring = response.substring(1, response.length() - 1);
                        String[] strArr = substring.split(",");
                        // 在这里进行UI操作，将结果显示到界面上
                        if ("FAIL".equals(strArr[0])) {
                            new AlertDialog.Builder(LoginActivity.this).setTitle("登录信息有误")
                                    .setMessage("请输入正确的用户名和密码")
                                    .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                                        @Override
                                        public void onClick(DialogInterface dialogInterface, int i) {
                                            //finish();
                                        }
                                    }).show();
                            UserNameEdit.setText("");
                            PassWordEdit.setText("");
                            UserNameEdit.requestFocus();//获取焦点 光标出现
                        } else if ("SUCCESS".equals(strArr[0])) {
                            editor = pref.edit();
                            editor.putBoolean("remember_password", true);
                            editor.putString("Tel", username_input.trim());
                            editor.putString("password", password_input.trim());
                            editor.putInt("userId",Integer.parseInt(strArr[1].trim()));
                            editor.putString("userName",strArr[2].trim());
                            editor.putString("area",strArr[3].trim());
                            editor.putString("buildingNumber",strArr[4].trim());
                            editor.putFloat("coin",Float.parseFloat(strArr[5].trim()));
                            editor.putInt("cred",Integer.parseInt(strArr[6].trim()));
                            editor.apply();
                            String msg = "欢迎! \n 您输入的手机号是:" + username_input + "\n";
                            //用toast来显示提示信息
                            Toast.makeText(LoginActivity.this, msg, Toast.LENGTH_LONG).show();
                            Intent intent = new Intent(LoginActivity.this, MainActivity.class);
                            //修改
                            startActivity(intent);
                        }


                    }
                });
            }
        });
    }
}
//    @Override
//    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
//        super.onActivityResult(requestCode, resultCode, data);
//        if(requestCode == 1)
//        {
//            if((resultCode != RESULT_OK) || (data == null))
//                return;
//            Bundle bundle = data.getExtras();
//            userName = bundle.getString("userName","999");
//            pw_msg = bundle.getString("pw_msg","999");
//        }
//    }
//    }
