package com.example.bytheway.Activity;

import android.graphics.Color;
import android.os.Bundle;
import android.view.View;
import android.widget.ImageButton;
import android.widget.LinearLayout;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;
import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentTransaction;

import com.example.bytheway.R;
import com.example.bytheway.ui.help.HelpFragment;
import com.example.bytheway.ui.home.HomeFragment;
import com.example.bytheway.ui.out.OutFragment;
import com.example.bytheway.ui.zone.ZoneFragment;

import java.util.ArrayList;
import java.util.List;

public class
MainActivity extends AppCompatActivity {
   // public static User user;
    //装载 Fragment 的集合
    private List<Fragment> mFragments;
    //四个 Tab 对应的布局
    private LinearLayout mTabHome;
    private LinearLayout mTabOut;
    private LinearLayout mTabHelp;
    private LinearLayout mTabZone;
    //四个 Tab 对应的 ImageButton
    private ImageButton mImgHome;
    private ImageButton mImgOut;
    private ImageButton mImgHelp;
    private ImageButton mImgZone;
    private TextView title,textHome,textOut,textHelp,textZone;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        initFragments(); //初始化碎片
        initViews(); //初始化控件
        initEvents(); //初始化事件
        initFirstRun(0);//第一次运行初始化界面，第一个碎片
//        user=new User();
//        user.defaultUser();


    }

    private  void  initFragments(){//初始化碎片
        mFragments = new ArrayList<>();
        mFragments.add(new HomeFragment());
        mFragments.add(new OutFragment());
        mFragments.add(new HelpFragment());
        mFragments.add(new ZoneFragment());

    }

    private void initViews(){//初始化控件
        mTabHome=(LinearLayout)findViewById(R.id.id_tab_home);
        mTabOut=(LinearLayout)findViewById(R.id.id_tab_out);
        mTabHelp=(LinearLayout)findViewById(R.id.id_tab_help);
        mTabZone=(LinearLayout)findViewById(R.id.id_tab_zone);
        mImgHome=(ImageButton) findViewById(R.id.to_home);
        mImgOut=(ImageButton)findViewById(R.id.to_out);
        mImgHelp=(ImageButton)findViewById(R.id.to_help);
        mImgZone=(ImageButton)findViewById(R.id.to_zone);
        title=(TextView)findViewById(R.id.title_text);
        textHome=(TextView)findViewById(R.id.text_home);
        textOut=(TextView)findViewById(R.id.text_out);
        textHelp=(TextView)findViewById(R.id.text_help);
        textZone=(TextView)findViewById(R.id.text_zone);

    }

    private void initEvents(){
       //初始化点击事件
        mTabHome.setOnClickListener(onClickListener);
        mTabOut.setOnClickListener(onClickListener);
        mTabHelp.setOnClickListener(onClickListener);
        mTabZone.setOnClickListener(onClickListener);
    }
    View.OnClickListener onClickListener = new View.OnClickListener() {
        public void onClick(View v) {
            //先将四个 ImageButton 置为灰色
            resetImgs();
            //根据点击的 Tab 切换不同的页面及设置对应的 ImageButton 为绿色
            switch (v.getId()) {
                case R.id.id_tab_home: selectTab(0); break;
                case R.id.id_tab_out: selectTab(1); break;
                case R.id.id_tab_help: selectTab(2); break;
                case R.id.id_tab_zone: selectTab(3); break;
            }
        }
    };

    private void resetImgs() {//设为未点击状态，灰色
        mImgHome.setImageResource(R.mipmap.home1);
        textHome.setTextColor(Color.parseColor("#cdcdcd"));
        mImgOut.setImageResource(R.mipmap.out1);
        textOut.setTextColor(Color.parseColor("#cdcdcd"));
        mImgHelp.setImageResource(R.mipmap.help1);
        textHelp.setTextColor(Color.parseColor("#cdcdcd"));
        mImgZone.setImageResource(R.mipmap.zone1);
        textZone.setTextColor(Color.parseColor("#cdcdcd"));
    }

    private void selectTab(int i) {
        //根据点击的 Tab 设置对应的 ImageButton 为白色
        switch (i) {
            case 0: mImgHome.setImageResource(R.mipmap.home2); title.setText(R.string.title_home);textHome.setTextColor(Color.parseColor("#8ED792"));break;
            case 1: mImgOut.setImageResource(R.mipmap.out2);title.setText(R.string.title_out);textOut.setTextColor(Color.parseColor("#8ED792"));break;
            case 2: mImgHelp.setImageResource(R.mipmap.help2);title.setText(R.string.title_help);textHelp.setTextColor(Color.parseColor("#8ED792"));break;
            case 3: mImgZone.setImageResource(R.mipmap.zone2);title.setText(R.string.title_zone);textZone.setTextColor(Color.parseColor("#8ED792"));break;
        }
        //设置当前点击的 Tab 所对应的页面
        setCurrentFragment(i);
    }

    //设置当前应该显示的碎片
    private void setCurrentFragment(int i)
    {
        FragmentManager fm = getSupportFragmentManager();
        FragmentTransaction trans = fm.beginTransaction();
        trans.replace(R.id.frag_layout, mFragments.get(i));
        trans.commit();
    }

    private void initFirstRun(int i)//第一次打开app显示的界面
    {
        resetImgs(); //重置所有 Tab
        selectTab(i); //显示第 i 个碎片
    }




}