package com.example.bytheway.Activity;

import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Typeface;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import android.view.WindowManager;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;

import com.example.bytheway.R;
import com.example.bytheway.UrlObject.UrlObject;

import java.io.IOException;

import okhttp3.Call;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

public class RegisterActivity extends AppCompatActivity{
    private SharedPreferences pref;
    private EditText regis_Tel;
    private EditText regis_Password;
    private EditText regis_UserName;
    private EditText regis_Sex;
    private EditText regis_Age;
    private EditText regis_Area;
    private EditText regis_Building;
    private EditText regis_Sno;
    private EditText regis_CHSI;
    private Button Register;
    String page_url = UrlObject.url_path + "Reglet";
    private static final String TAG = "RegisterActivity";
    String responseData;
    String Tel,Password,UserName,Sex,Area,Building,Sno,CHSI;
    int Age;

    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_register);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
        //获取haredPreferences实例
        pref = PreferenceManager.getDefaultSharedPreferences(this);
        regis_Tel = (EditText) findViewById(R.id.regis_Tel);
        regis_Password = (EditText) findViewById(R.id.regis_Password);
        regis_UserName = (EditText) findViewById(R.id.regis_UserName);
        regis_Sex = (EditText) findViewById(R.id.regis_Sex);
        regis_Age = (EditText) findViewById(R.id.regis_Age);
        regis_Area = (EditText) findViewById(R.id.regis_Area);
        regis_Building = (EditText) findViewById(R.id.regis_Building);
        regis_Sno = (EditText) findViewById(R.id.regis_Sno);
        regis_CHSI = (EditText) findViewById(R.id.regis_CHSI);
        Register = (Button) findViewById(R.id.register_button);

        Register.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Tel = regis_Tel.getText().toString().trim();
                Password = regis_Password.getText().toString().trim();
                UserName = regis_UserName.getText().toString().trim();
                Sex = regis_Sex.getText().toString().trim();
                Age = Integer.parseInt(regis_Age.getText().toString());
                Area = regis_Area.getText().toString().trim();
                Building = regis_Building.getText().toString().trim();
                Sno = regis_Sno.getText().toString().trim();
                CHSI = regis_CHSI.getText().toString().trim();
                okhttp3.Callback callback = new okhttp3.Callback() {
                    @Override
                    public void onResponse(Call call, Response response) throws IOException {
                        responseData = response.body().string();
                        Log.d(TAG, "服务器返回成功" + responseData);
                        showResponse(responseData);
                    }

                    @Override
                    public void onFailure(Call call, IOException e) {
                        responseData = "Error!";
                        Log.e(TAG, "服务器返回失败");
                        showResponse(responseData);
                    }
                };

                OkHttpClient client = new OkHttpClient();
                //GET请求
                String getURL = page_url + "?Tel=" + Tel + "&Password=" + Password + "&UserName=" + UserName + "&Sex=" + Sex + "&Age=" + Age + "&Area=" + Area + "&BuildingNumber=" + Building + "&CHSI=" + CHSI + "&Sno=" + Sno;
                Request request = new Request.Builder()
                        .url(getURL)
                        .build();
                client.newCall(request).enqueue(callback);


            }

            private void showResponse(final String response) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        // 在这里进行UI操作，将结果显示到界面上
                        if ("FAIL".equals(response)) {
                            new AlertDialog.Builder(RegisterActivity.this).setTitle("注册信息有误")
                                    .setMessage("请重新注册")
                                    .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                                        @Override
                                        public void onClick(DialogInterface dialogInterface, int i) {
                                            //finish();
                                        }
                                    }).show();
                            regis_Age.setText("");
                            regis_Tel.setText("");
                            regis_Area.setText("");
                            regis_Building.setText("");
                            regis_CHSI.setText("");
                            regis_Password.setText("");
                            regis_Sex.setText("");
                            regis_Sno.setText("");
                            regis_UserName.setText("");
                            regis_Tel.requestFocus();//获取焦点 光标出现
                        } else if ("R_SUCCESS".equals(response)) {
                            String msg = "欢迎! \n 您注册的用户名:" + UserName + "\n";
                            //用toast来显示提示信息
                            Toast.makeText(RegisterActivity.this, msg, Toast.LENGTH_LONG).show();
                            Intent intent = new Intent(RegisterActivity.this, LoginActivity.class);
                            //修改
                            intent.putExtra("UserName", UserName);
                            //修改
                            startActivity(intent);
                        }
                    }
                });
            }
        });
    }
}