package com.example.bytheway.Activity;

import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Typeface;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import android.view.WindowManager;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;

import com.example.bytheway.R;
import com.example.bytheway.UrlObject.UrlObject;

import java.io.IOException;

import okhttp3.Call;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

public class RegisterActivityTwo extends AppCompatActivity {
    private EditText SexEdit,AgeEdit,AreaEdit,BuildingEdit,SnoEdit,CHSIEdit;
    private Button Previous_Button,SignUp_Button;
    private static final String TAG = "RegisterActivityTwo";
    private SharedPreferences pref;
    String responseData;
    String page_url = UrlObject.url_path + "Reglet";
    String RegisterName,RegisterTel,RegisterPassword,RegisterSex,RegisterArea,RegisterBuilding,RegisterSno,RegisterCHSI;
    int RegisterAge;

    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_register_pagetwo);
        getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
        SexEdit = (EditText)findViewById(R.id.SexEdit);
        AgeEdit = (EditText)findViewById(R.id.AgeEdit);
        AreaEdit = (EditText)findViewById(R.id.AreaEdit);
        BuildingEdit = (EditText)findViewById(R.id.BuildingEdit);
        SnoEdit = (EditText)findViewById(R.id.SnoEdit);
        CHSIEdit = (EditText)findViewById(R.id.CHSIEdit);
        Previous_Button = (Button)findViewById(R.id.Previous_Button);
        SignUp_Button = (Button)findViewById(R.id.SignUp_Button);
        Previous_Button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent1 = new Intent(RegisterActivityTwo.this,RegisterActivityOne.class);
                startActivity(intent1);
            }
        });
        SignUp_Button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intent = getIntent();
                RegisterTel = intent.getStringExtra("UserRegisterTel");
                RegisterName = intent.getStringExtra("UserRegisterName");
                RegisterPassword = intent.getStringExtra("RegisterPassword");
                RegisterSex = SexEdit.getText().toString().trim();
                RegisterAge = Integer.parseInt(AgeEdit.getText().toString().trim());
                RegisterArea = AreaEdit.getText().toString().trim();
                RegisterBuilding = BuildingEdit.getText().toString().trim();
                RegisterSno = SnoEdit.getText().toString().trim();
                RegisterCHSI = CHSIEdit.getText().toString().trim();
                okhttp3.Callback callback = new okhttp3.Callback() {
                    @Override
                    public void onResponse(Call call, Response response) throws IOException {
                        responseData = response.body().string();
                        Log.d(TAG, "服务器返回成功" + responseData);
                        showResponse(responseData);
                    }

                    @Override
                    public void onFailure(Call call, IOException e) {
                        responseData = "Error!";
                        Log.e(TAG, "服务器返回失败");
                        showResponse(responseData);
                    }
                };

                OkHttpClient client = new OkHttpClient();
                //GET请求
                String getURL = page_url + "?Tel=" + RegisterTel + "&Password=" + RegisterPassword + "&UserName=" + RegisterName + "&Sex=" + RegisterSex + "&Age=" + RegisterAge + "&Area=" + RegisterArea + "&BuildingNumber=" + RegisterBuilding + "&CHSI=" + RegisterCHSI + "&Sno=" + RegisterSno;
                Request request = new Request.Builder()
                        .url(getURL)
                        .build();
                client.newCall(request).enqueue(callback);


            }

            private void showResponse(final String response) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        // 在这里进行UI操作，将结果显示到界面上
                        if ("FAIL".equals(response)) {
                            new AlertDialog.Builder(RegisterActivityTwo.this).setTitle("注册信息有误")
                                    .setMessage("请重新注册")
                                    .setPositiveButton("确定", new DialogInterface.OnClickListener() {
                                        @Override
                                        public void onClick(DialogInterface dialogInterface, int i) {
                                            //finish();
                                        }
                                    }).show();
                            AgeEdit.setText("");
                            SexEdit.setText("");
                            AreaEdit.setText("");
                            BuildingEdit.setText("");
                            SnoEdit.setText("");
                            CHSIEdit.setText("");
                            SexEdit.requestFocus();//获取焦点 光标出现
                        } else if ("R_SUCCESS".equals(response)) {
                            String msg = "欢迎! \n 您注册的用户名:" + RegisterName + "\n";
                            //用toast来显示提示信息
                            Toast.makeText(RegisterActivityTwo.this, msg, Toast.LENGTH_LONG).show();
                            Intent intent = new Intent(RegisterActivityTwo.this, LoginActivity.class);
                            //修改
                            intent.putExtra("UserName", RegisterName);
                            //修改
                            startActivity(intent);
                        }



            }
        });
            }
        });
    }}
