package com.example.bytheway.Activity;


import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.example.bytheway.R;
import com.example.bytheway.UrlObject.UrlObject;
import com.example.bytheway.ui.home.Home;
import com.google.gson.Gson;

import java.net.URL;

import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

//订单详情页，接单功能在这里
public class order_DetailsActivity extends AppCompatActivity implements View.OnClickListener{

    Home order;
    ImageView user_head;
    TextView user_name,order_type,order_from,order_to,reward,note,user_cred;
    Button order_take;//接单
    ImageButton back;
    private SharedPreferences pref;
    String result;
    int take_order_result=0;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_order__details);
        initView();
    }

    private void initView(){
        user_head=(ImageView)findViewById(R.id.details_user_head);
        user_name=(TextView) findViewById(R.id.details_user_name);
        user_cred=(TextView)findViewById(R.id.details_user_cred);
        order_type=(TextView)findViewById(R.id.details_order_type);
        order_from=(TextView)findViewById(R.id.details_fromStation);
        order_to=(TextView)findViewById(R.id.details_toStation);
        reward=(TextView)findViewById(R.id.details_order_reward);
        note=(TextView)findViewById(R.id.details_order_note);
        order_take=(Button)findViewById(R.id.details_order_take);
        order_take.setOnClickListener(this);
        back=(ImageButton)findViewById(R.id.order_details_back);
        back.setOnClickListener(this);
        setInfo();
    }


    private void setInfo(){
        Intent intent=getIntent();
        String orderJson=intent.getStringExtra("order");
        pref = PreferenceManager.getDefaultSharedPreferences(this);
        order=new Gson().fromJson(orderJson,Home.class);
        user_head.setImageResource(order.getUser_head());
        user_name.setText(order.getOrderManName());
        //user_cred
        order_type.setText(order.getType());
        order_from.setText(order.getOrderFrom());
        order_to.setText(order.getOrderTo());
        reward.setText(String.valueOf(order.getReward()));
        note.setText(order.getNote());

    }

    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.order_details_back:
                Toast.makeText(this,"back",Toast.LENGTH_SHORT).show();
                finish();break;
            case R.id.details_order_take://接单按钮click事件
                if(pref.getInt("userId",0)!=order.getOrderManId()) {
                    Thread t = new Thread() {
                        public void run() {
                            result = takeOrder();
                            Log.d("takeOrder", result);
                        }
                    };
                    t.start();
                    while (t.isAlive()) {
                        ;
                    }
                    if (result.equals("SUCCESS")) {
                        Toast.makeText(this, "take", Toast.LENGTH_SHORT).show();
                        take_order_result = 1;
                        setResult(take_order_result);
                        finish();
                    }
                }else {
                    Toast.makeText(this, "可不能接自己的单哦", Toast.LENGTH_SHORT).show();
                }
                break;
            default:break;
        }
    }

    //takeOrder方法 接单方法
    public String takeOrder(){

        try {
            String path= UrlObject.url_path+"takeOrderServlet";//takeOrder  url
            URL url=new URL(path);
            OkHttpClient client=new OkHttpClient();
            RequestBody requestBody=new FormBody.Builder()
                    .add("orderId",String.valueOf(order.getOrderId()))
                    .add("getManId",String.valueOf(pref.getInt("userId",0)))
                    .build();
            Request request=new Request.Builder()
                    .url(url)
                    .post(requestBody)
                    .build();
            Response response=client.newCall(request).execute();
            String responseData=response.body().string();
            return responseData;



        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;

    }
}