package com.example.bytheway.Activity;

import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.widget.ImageButton;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.bytheway.R;
import com.example.bytheway.ui.home.Home;
import com.example.bytheway.ui.home.OrderHistoryAdapter;

import java.util.ArrayList;
import java.util.List;

public class order_historyActivity extends AppCompatActivity {
    ImageButton back;
    List<Home> orders=new ArrayList<>();
    RecyclerView recyclerView;
    protected OrderHistoryAdapter adapter;
    private SharedPreferences pref;
    int userId;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_order_history);
        initView();
    }

    private void initView(){
        back=(ImageButton)findViewById(R.id.order_history_back);
        back.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
            }
        });
        recyclerView=(RecyclerView)findViewById(R.id.order_history_list);
        LinearLayoutManager layoutManager = new LinearLayoutManager(this);
        recyclerView.setLayoutManager(layoutManager);
        setOrderHistory();

    }

    public  void setOrderHistory(){
        pref = PreferenceManager.getDefaultSharedPreferences(this);
        userId=pref.getInt("userId",0);
        Thread t=new Thread(){
            public void run(){
                orders=OrderHistoryAdapter.findOrderHistory(userId);
                Log.d("findHistoryOrder",String.valueOf(orders.size()));
            }
        };
        t.start();
        while (t.isAlive()){
            ;
        }
        adapter=new OrderHistoryAdapter(orders,userId);
        recyclerView.setAdapter(adapter);

    }


}