package com.example.bytheway.Activity;


import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.text.TextUtils;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;

import com.example.bytheway.R;
import com.example.bytheway.UrlObject.UrlObject;
import com.example.bytheway.ui.help.Help;

import java.net.URL;

import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

//发帖界面，点击论坛界面加号进入
public class post_AddActivity extends AppCompatActivity implements View.OnClickListener{
    Help newPost=new Help();
    ImageButton post_add_back;
    Button post_add_confirm;
    EditText post_title,post_content,post_reward;
    private SharedPreferences pref;
    int add_result=0;
    String result;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_post__add);
        initView();
    }

    private void initView(){
        post_add_back=(ImageButton)findViewById(R.id.add_post_back);
        post_add_confirm=(Button)findViewById(R.id.add_post_confirm);
        post_title=(EditText)findViewById(R.id.post_title_edit);
        post_content=(EditText)findViewById(R.id.post_content_edit);
        post_reward=(EditText)findViewById(R.id.post_reward_edit);
        post_add_back.setOnClickListener(this);
        post_add_confirm.setOnClickListener(this);
    }


    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.add_post_back:
                Toast.makeText(this,"back",Toast.LENGTH_SHORT).show();
                finish();break;
            case R.id.add_post_confirm://确认发单按钮
                if(TextUtils.isEmpty(post_title.getText())){
                    Toast.makeText(this,"不取一个响亮的标题嘛？",Toast.LENGTH_SHORT).show();
                }else if(TextUtils.isEmpty(post_content.getText())){
                    Toast.makeText(this,"好的帖子需要内容哦!",Toast.LENGTH_SHORT).show();
                }
                else {
                    Thread t = new Thread() {

                        public void run() {
                            newPostInfo();
                            result = addPost(newPost);
                            Log.d("addPost", result);
                        }
                    };
                    t.start();
                    while (t.isAlive()) {
                        ;
                    }
                    if ("SUCCESS".equals(result)) {
                        Toast.makeText(this, "post!", Toast.LENGTH_SHORT).show();
                        add_result = 1;//发布成功
                        setResult(add_result);
                        finish();
                    }
                }
                break;
            default:break;
        }
    }

    public void newPostInfo(){
        pref = PreferenceManager.getDefaultSharedPreferences(this);
        //newPost.setPostId();
        newPost.setUserId(pref.getInt("userId",0));
        newPost.setPostUserName(pref.getString("userName","sb"));
        newPost.setTitle(post_title.getText().toString());
        newPost.setPostContent(post_content.getText().toString());
        if(TextUtils.isEmpty(post_reward.getText())){
            newPost.setPay(0);
        }else {
            newPost.setPay(Float.parseFloat(post_reward.getText().toString()));
        }

    }
    //发帖方法addPost();

    public static String addPost(Help post){
        try {
            String path= UrlObject.url_path+"addPost";//addpost  url
            URL url=new URL(path);
            OkHttpClient client=new OkHttpClient();
            RequestBody requestBody=new FormBody.Builder()
                    //.add("postId",)
                    .add("postUserId",String.valueOf(post.getUserId()))
                    .add("postUserName",post.getPostUserName())
                    .add("title",post.getTitle())
                    .add("postContent",post.getPostContent())
                    .add("pay",String.valueOf(post.getPay()))
                    .add("postStatus","0")
                    .build();
            Request request=new Request.Builder()
                    .url(url)
                    .post(requestBody)
                    .build();
            Response response=client.newCall(request).execute();
            String responseData=response.body().string();
            return responseData;

        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }
}