package com.example.bytheway.Activity;


import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.bytheway.R;
import com.example.bytheway.UrlObject.UrlObject;
import com.example.bytheway.ui.help.Answer;
import com.example.bytheway.ui.help.AnswerAdapter;
import com.example.bytheway.ui.help.Help;
import com.google.gson.Gson;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

//帖子详情界面，点击帖子进入
public class post_DetailsActivity extends AppCompatActivity implements View.OnClickListener {
    Help post;
    TextView post_title,post_userName,post_content;
    ImageView post_userHead;
    ImageButton back;
    EditText answer_edit;
    Button answer_confirm;
    List<Answer> answers=new ArrayList<>();
//    ImageView answer_userHead;
//    TextView answer_userName,answer_floor,answer_content;
    RecyclerView recyclerView;
    protected AnswerAdapter adapter;
    private SharedPreferences pref;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_post__details);
        initView();


    }

    private void initView(){
        post_title=(TextView)findViewById(R.id.post_details_title);
        post_userName=(TextView)findViewById(R.id.post_details_userName);
        post_content=(TextView)findViewById(R.id.post_details_content);
        post_userHead=(ImageView)findViewById(R.id.post_details_userHead);
        back=(ImageButton)findViewById(R.id.post_details_back);
        back.setOnClickListener(this);
        answer_edit=(EditText)findViewById(R.id.answer_to_post);
        answer_confirm=(Button)findViewById(R.id.answer_confirm);
        answer_confirm.setOnClickListener(this);
        setPost();
        recyclerView=(RecyclerView)findViewById(R.id.answer_list);
        LinearLayoutManager layoutManager = new LinearLayoutManager(this);
        recyclerView.setLayoutManager(layoutManager);
        setAnswers();
    }

    private void setPost(){
        Intent intent=getIntent();
        String postJson=intent.getStringExtra("post");
        post=new Gson().fromJson(postJson,Help.class);
        post_title.setText(post.getTitle());
        post_userName.setText(post.getPostUserName());
        post_content.setText(post.getPostContent());
        post_userHead.setImageResource(post.getUser_head());

    }

    public void setAnswers(){
        Thread t=new Thread(){
            public void run() {
                answers=AnswerAdapter.findAnswer(post.getPostId());
                Log.d("findAnswer",String.valueOf(answers.size()));
            }
        };
        t.start();
        while (t.isAlive()){
            ;
        }

        adapter=new AnswerAdapter(answers);
        recyclerView.setAdapter(adapter);

    }


    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.post_details_back:
                Toast.makeText(this,"back",Toast.LENGTH_SHORT).show();
                finish();break;
            case R.id.answer_confirm:
                Thread t=new Thread(){
                    public void run() {
                        String result=addAnswer();
                        Log.d("addAnswer",result);
                    }
                };
                t.start();
                while (t.isAlive()){
                    ;
                }
                Toast.makeText(this,"answer",Toast.LENGTH_SHORT).show();
                setAnswers();
                answer_edit.setText("");
                break;
            default:break;
        }
    }

//    public Answer newAnswerInfo(Answer answer){
//        answer.setPostId(post.getPostId());
//        answer.setAnswerManId(pref.getInt("userID",0));
//        answer.setAnswerManName(pref.getString("userName","sb"));
//        answer.setAnswerContent(answer_edit.getText().toString());
//        return answer;
//    }

    public String addAnswer(){
        Answer answer=new Answer();
        pref = PreferenceManager.getDefaultSharedPreferences(this);
        answer.setPostId(post.getPostId());
        answer.setAnswerManId(pref.getInt("userId",0));
        answer.setAnswerManName(pref.getString("userName","sb"));
        answer.setAnswerContent(answer_edit.getText().toString());
        try{
            String path= UrlObject.url_path+"addAnswer";//addpost  url
            URL url=new URL(path);
            OkHttpClient client=new OkHttpClient();
            RequestBody requestBody=new FormBody.Builder()
                    .add("postId",String.valueOf(answer.getPostId()))
                    .add("answerManId",String.valueOf(answer.getAnswerManId()))
                    .add("answerManName",answer.getAnswerManName())
                    .add("answerContent",answer.getAnswerContent())
                    .build();
            Request request=new Request.Builder()
                    .url(url)
                    .post(requestBody)
                    .build();
            Response response=client.newCall(request).execute();
            String responseData=response.body().string();
            return responseData;

        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }
}