package com.example.bytheway.ui.help;

import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.bytheway.R;
import com.example.bytheway.UrlObject.UrlObject;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import okhttp3.Call;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

public class HelpAdapter extends RecyclerView.Adapter<HelpAdapter.ViewHolder>{

    private List<Help> helps;
    detailsListener toDetails;

    public interface detailsListener {//利用接口回调 把点击的帖子内容传到详情活动里
        public void onDetailsClick(Help post);
    }
    public void setOnDetailsClickListener (HelpAdapter.detailsListener XXListener) {
        this.toDetails = XXListener;
    }

    public static class ViewHolder extends RecyclerView.ViewHolder {
        ImageView userHead;
        TextView userName;
       // TextView time;
        TextView postTitle,postContent;
        Button details;

        public ViewHolder(@NonNull View itemView) {
            super(itemView);
            this.userHead=(ImageView)itemView.findViewById(R.id.zone_user_head);
            this.userName = (TextView) itemView.findViewById(R.id.helpUserName);
           // this.time = (TextView) itemView.findViewById(R.id.helpTime);
            this.postTitle=(TextView)itemView.findViewById(R.id.post_title);
            this.postContent = (TextView) itemView.findViewById(R.id.post_content);
            this.details=(Button)itemView.findViewById(R.id.post_details);
        }
    }

    public HelpAdapter(List<Help> helps) {
        this.helps = helps; }

    @NonNull
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.helping_post, parent, false);
        final ViewHolder holder = new ViewHolder(view);
        Log.d("HelpAdapter", "onCreateViewHolder: ");
        holder.details.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                int position=holder.getAdapterPosition();
                Help post=helps.get(position);
                toDetails.onDetailsClick(post);
            }
        });
        return holder;
    }

    public void onBindViewHolder(@NonNull ViewHolder holder, int position) {
        Help help = helps.get(position);
        holder.userHead.setImageResource(help.getUser_head());
        holder.userName.setText(help.getPostUserName());
       // holder.time.setText(help.getTime());
        holder.postTitle.setText(help.getTitle());
        holder.postContent.setText(help.getPostContent());
        Log.d("HelpAdapter", "onBindViewHolder: " + position);
    }

    public int getItemCount() {
        return helps.size();
    }

    public static List<Help> findHelp() {



        try {
            String path = UrlObject.url_path + "ClientPostInfoServlet?id=0";
            URL url = new URL(path);

            OkHttpClient client = new OkHttpClient();
            Request request = new Request.Builder()
                    .url(url)
                    .build();
            Call call = client.newCall(request);
            Response response = call.execute();

            String responseData = response.body().string();
            Gson gson = new Gson();
            List<Help> helps = gson.fromJson(responseData, new TypeToken<List<Help>>() {
            }.getType());
            List<Help> reverse_helps=new ArrayList<>();
            for (int i=helps.size();i>0;i--){
                reverse_helps.add(helps.get(i-1));
            }
            return reverse_helps;


        } catch (Exception e) {
            e.printStackTrace();
        }
        return  null;
    }

    public static List<Help> findPost_test(){

        List<Help> helps = new ArrayList<>();
        Help help1=new Help("孙悦超",1,"求xxs资源！在线等",R.mipmap.defaulthead);
        help1.setTitle("开导");
        helps.add(help1);
        Help help2=new Help("刘辉",2,"有妹妹带我上分吗",R.drawable.head2);
        helps.add(help2);
        Help help3=new Help("白天",3,"有人出二手考研资料吗？",R.drawable.head1);
        helps.add(help3);
        Help help4=new Help("李志宏",4,"推荐一下学校附近有适合两个人去的好吃点",R.drawable.head2);
        helps.add(help4);
        return  helps;

    }


}
