package com.example.bytheway.ui.help;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.bytheway.Activity.post_AddActivity;
import com.example.bytheway.Activity.post_DetailsActivity;
import com.example.bytheway.R;
import com.google.gson.Gson;

import java.util.ArrayList;
import java.util.List;
//帖子界面，也就是底部导航第三个界面
public class HelpFragment extends Fragment {
    ImageView user_head;
    TextView user_name,time,postTitle,postContent;
    List<Help> helps=new ArrayList<>();
    View view=null;
    protected HelpAdapter adapter;
    RecyclerView recyclerView;
    ImageButton add_post;
    Button post_details;

    public HelpFragment(){

    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        if(view==null){
            view=inflater.inflate(R.layout.fragment_help,container,false);
            user_head=(ImageView)view.findViewById(R.id.zone_user_head);
            user_name=(TextView)view.findViewById(R.id.helpUserName);
            //time=(TextView)view.findViewById(R.id.helpTime);
            postTitle=(TextView)view.findViewById(R.id.post_title);
            postContent=(TextView)view.findViewById(R.id.post_content);
            add_post=(ImageButton)view.findViewById(R.id.post_button);
            post_details=(Button)view.findViewById(R.id.post_details);
            add_post.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    Toast.makeText(getContext(),"add_post",Toast.LENGTH_SHORT).show();
                    Intent intent=new Intent(getActivity(),post_AddActivity.class);
                    startActivityForResult(intent,3);
                }
            });
            recyclerView=(RecyclerView)view.findViewById(R.id.help_list);
            LinearLayoutManager layoutManager = new LinearLayoutManager(this.getActivity());
            recyclerView.setLayoutManager(layoutManager);
            setHelp();

        }

        return view;
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if(requestCode==3&&resultCode==1){//1为发布了新帖子
            setHelp();
        }

    }

    public void setHelp(){
        Thread t=new Thread(){

            public void run() {
                helps= HelpAdapter.findHelp();
                Log.d("findOrder",String.valueOf(helps.size()));
            }
        };
        t.start();
        while (t.isAlive()){
            ;
        }
       // helps=HelpAdapter.findPost_test();
        adapter=new HelpAdapter(helps);
        recyclerView.setAdapter(adapter);
        adapter.setOnDetailsClickListener(new HelpAdapter.detailsListener() {//adapter的点击事件，将该adapter的数据传给详情活动
            @Override
            public void onDetailsClick(Help post) {
                Intent intent=new Intent(getActivity(), post_DetailsActivity.class);
                intent.putExtra("post",new Gson().toJson(post));
                startActivity(intent);
            }
        });

    }
}
