package com.example.bytheway.ui.home;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.example.bytheway.Activity.order_DetailsActivity;
import com.example.bytheway.R;
import com.example.bytheway.UrlObject.UrlObject;
import com.google.gson.Gson;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import okhttp3.Call;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

public class HomeFragment extends Fragment {
    ImageView user_head;
    TextView user_name,order_from,order_to;
    Button details;
    List<Home> homes=new ArrayList<>();
    View view=null;
    protected HomeAdapter adapter;
    RecyclerView recyclerView;
    IntentFilter filter;
    private SharedPreferences pref;
    private SharedPreferences.Editor editor;

    public HomeFragment(){

    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        pref = PreferenceManager.getDefaultSharedPreferences(getContext());
        editor = pref.edit();
        filter=new IntentFilter();
        filter.addAction("com.example.addOrder");
        BroadcastReceiver addOrderReceive=new BroadcastReceiver() {
            @Override
            public void onReceive(Context context, Intent intent) {
                if(intent.getAction()=="com.example.addOrder"){
                    setHome();
                    findCoin_onAddOrder();
                }
            }
        };
        getActivity().registerReceiver(addOrderReceive,filter);


    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
       if(view==null){
           view=inflater.inflate(R.layout.fragment_home,container,false);
           user_head=(ImageView)view.findViewById(R.id.headlogo);
           user_name=(TextView)view.findViewById(R.id.user_name);
           order_from=(TextView)view.findViewById(R.id.orderFrom);
           order_to=(TextView)view.findViewById(R.id.orderTo);
           details=(Button)view.findViewById(R.id.order_details);
           recyclerView=(RecyclerView)view.findViewById(R.id.order_list);
           LinearLayoutManager layoutManager = new LinearLayoutManager(this.getActivity());
           recyclerView.setLayoutManager(layoutManager);
            setHome();
       }

       return view;
    }

    public void setHome(){
        Thread t=new Thread(){

            public void run() {
                homes=HomeAdapter.findHome();
                Log.d("findOrder",String.valueOf(homes.size()));
            }
        };
        t.start();
        while (t.isAlive()){
            ;
        }
       // homes=HomeAdapter.findHome_test();//test 与上面互斥
        adapter=new HomeAdapter(homes);
        recyclerView.setAdapter(adapter);
        adapter.setOnDetailsClickListener(new HomeAdapter.detailsListener() {
            @Override
            public void onDetailsClick(Home order) {//列表项点击事件，把数据用intent传给订单详情活动
                Intent intent=new Intent(getActivity(), order_DetailsActivity.class);
                intent.putExtra("order",new Gson().toJson(order));
                startActivityForResult(intent,4);

            }
        });
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if(requestCode==4&&resultCode==1){//1为接了单
            setHome();
        }

    }

    public void findCoin_onAddOrder(){
        Thread t=new Thread(){
          public void run(){

              String userName,userPassword;
              userName=pref.getString("Tel","sb");
              userPassword=pref.getString("password","0");
              try {
                  String page_url = UrlObject.url_path + "aslogin";
                  String getURL = page_url + "?Tel=" + userName + "&Password=" + userPassword;
                  URL url = new URL(getURL);

                  OkHttpClient client = new OkHttpClient();
                  Request request = new Request.Builder()
                          .url(url)
                          .build();
                  Call call = client.newCall(request);
                  Response response = call.execute();

                  String responseData = response.body().string();
                  String substring = responseData.substring(1, responseData.length() - 1);
                  String[] strArr = substring.split(",");
                  editor.putFloat("coin",Float.parseFloat(strArr[5].trim()));
                  editor.apply();

              } catch (Exception e) {
                  e.printStackTrace();
              }

          }
        };
        t.start();
        while (t.isAlive()){
            ;
        }
    }

//   public  class addOrderReceive extends BroadcastReceiver{
//        @Override
//        public void onReceive(Context context, Intent intent) {
//            setHome();
//        }
//    }



}