package com.example.bytheway.ui.home;

import android.app.Dialog;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.Button;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.RadioGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.example.bytheway.R;
import com.example.bytheway.UrlObject.UrlObject;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import java.net.URL;
import java.util.ArrayList;
import java.util.List;

import okhttp3.Call;
import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class OrderHistoryAdapter extends RecyclerView.Adapter<OrderHistoryAdapter.ViewHolder>{
    private  int userId;
    private List<Home> orders;
    SharedPreferences pref;
    Dialog dialog;
//    changeOrderListener changeOrder;
//
//    public interface changeOrderListener{
//        public void onChangeOrderClick();
//    }
//    public void setOnChangeOrderListener(OrderHistoryAdapter.changeOrderListener listener){
//        this.changeOrder=listener;
//    }


    public static class ViewHolder extends RecyclerView.ViewHolder{
        ImageView order_logo,order_status;
        TextView order_type,order_from,order_to,order_reward;

        public ViewHolder(@NonNull View itemView) {
            super(itemView);
            this.order_logo=(ImageView)itemView.findViewById(R.id.order_history_icon);
            this.order_type=(TextView)itemView.findViewById(R.id.order_history_type);
            this.order_from=(TextView)itemView.findViewById(R.id.order_history_fromStation);
            this.order_to=(TextView)itemView.findViewById(R.id.order_history_toStation);
            this.order_reward=(TextView)itemView.findViewById(R.id.order_history_reward);
            this.order_status=(ImageView)itemView.findViewById(R.id.order_history_status);
        }
    }

    public OrderHistoryAdapter(List<Home> orders,int userId){
        this.orders=orders;
        this.userId=userId;
    }
    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view= LayoutInflater.from(parent.getContext()).inflate(R.layout.history_order_list,parent,false);
        pref= PreferenceManager.getDefaultSharedPreferences(parent.getContext());
        userId=pref.getInt("userId",0);
        dialog=new Dialog(parent.getContext());
        final ViewHolder holder=new ViewHolder(view);
        return holder;
    }

    @Override
    public void onBindViewHolder(@NonNull OrderHistoryAdapter.ViewHolder holder, int position) {
        Home order=orders.get(position);
        holder.order_from.setText(order.getOrderFrom());
        holder.order_to.setText(order.getOrderTo());
        holder.order_reward.setText(String.valueOf(order.getReward()));
        if(order.getOrderManId()==userId){
            holder.order_logo.setImageResource(R.drawable.order1);
            holder.order_type.setText("我发的");
        }else {
            holder.order_logo.setImageResource(R.drawable.order3);
            holder.order_type.setText("我接的");
        }
        if(order.getOrderStatus()==0){
            holder.order_status.setImageResource(R.drawable.loading);
        }else if (order.getOrderStatus()==1) {
            holder.order_status.setImageResource(R.drawable.taken);
        }else if (order.getOrderStatus()==2){
            holder.order_status.setImageResource(R.drawable.yes);
        }else {
            holder.order_status.setImageResource(R.drawable.error);
        }

        if(order.getOrderManId()==userId&&order.getOrderStatus()==1){
            holder.order_status.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    int status=showDialog(order);
                    if(status!=1){

                    }
                    //修改订单状态
         //           changeOrderStatus(order.getOrderId(),status);
//                    Thread t=new Thread(){
//                        public void run(){
//                            String result=changeOrderStatus(order);
//                        }
//                    };
//                    t.start();
//                    while (t.isAlive()){
//                        ;
//                    }

                }
            });
        }


    }

    @Override
    public int getItemCount() {
        return orders.size();
    }

    public static List<Home> findOrderHistory(int userId) {


        try {
            String path = UrlObject.url_path + "ClientAllOrderServlet";
            URL url = new URL(path);

            OkHttpClient client = new OkHttpClient();
            Request request = new Request.Builder()
                    .url(url)
                    .build();
            Call call = client.newCall(request);
            Response response = call.execute();

            String responseData = response.body().string();

            Gson gson = new Gson();
            List<Home> orders = gson.fromJson(responseData, new TypeToken<List<Home>>() {
            }.getType());
            List<Home> order_history=new ArrayList<>();
            for (int i=orders.size();i>0;i--){
                Home order=orders.get(i-1);
                if (order.getOrderManId()==userId||order.getGetManId()==userId)
                order_history.add(order);
            }
            return order_history;



        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    /**
     * 弹出对话框，让用户决定修改与否
     *
     */
    public int showDialog(Home order){

        //去掉title
        dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
        dialog.show();
        Window window = dialog.getWindow();
        // 设置布局
        window.setContentView(R.layout.dialog_order_status);
        // 设置宽高
        window.setLayout(RadioGroup.LayoutParams.MATCH_PARENT, RadioGroup.LayoutParams.WRAP_CONTENT);
        window.setGravity(Gravity.CENTER);

        ImageView img = (ImageView)window.findViewById(R.id.order_dialog_img);
        TextView from = (TextView)window.findViewById(R.id.order_dialog_from);
        TextView to = (TextView)window.findViewById(R.id.order_dialog_to);
        TextView reward = (TextView)window.findViewById(R.id.order_dialog_reward);
        //TextView creator = (TextView)window.findViewById(R.id.meeting_creator_dialog);
        ImageButton finish=(ImageButton)window.findViewById(R.id.finish_dialog);
        Button destroy_btn = (Button) window.findViewById(R.id.destroy_dialog);
        Button cancel_btn = (Button) window.findViewById(R.id.cancel_dialog);
        Button confirm_btn = (Button) window.findViewById(R.id.confirm_dialog);

        from.setText(order.getOrderFrom());
        to.setText(order.getOrderTo());
        reward.setText(String.valueOf(order.getReward()));

        finish.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                dialog.cancel();
            }
        });
        destroy_btn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                order.setOrderStatus(-1);
                changeOrderStatus(order.getOrderId(),-1);
                dialog.cancel();
            }
        });
        cancel_btn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                order.setOrderStatus(0);
                changeOrderStatus(order.getOrderId(),0);
                dialog.cancel();
            }
        });
        confirm_btn.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                order.setOrderStatus(2);
                changeOrderStatus(order.getOrderId(),2);
                dialog.cancel();
            }
        });

        return order.getOrderStatus();

    }

    public void changeOrderStatus(int orderId,int orderStatus){
        Thread t=new Thread(){
            public void run(){
                try {
                    String path= UrlObject.url_path+"ClientChangeOrderServlet";//  url
                    URL url=new URL(path);
                    OkHttpClient client=new OkHttpClient();
                    RequestBody requestBody=new FormBody.Builder()
                            .add("orderId",String.valueOf(orderId))
                            .add("orderStatus",String.valueOf(orderStatus))
                            .build();
                    Request request=new Request.Builder()
                            .url(url)
                            .post(requestBody)
                            .build();
                    Response response=client.newCall(request).execute();
                    String responseData=response.body().string();
                    Log.d("changeOrder",responseData);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        };
        t.start();
        while (t.isAlive()){
            ;
        }


    }


}
