package com.example.bytheway.ui.out;

import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;

import com.example.bytheway.R;
import com.example.bytheway.UrlObject.UrlObject;
import com.example.bytheway.ui.home.Home;

import java.net.URL;

import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

//发单界面
public class OutFragment extends Fragment {
    Home newOrder=new Home();
    Spinner spinner_type;
    TextView user_name;
    TextView user_Tel;
    EditText out_time;
    EditText out_location;
    EditText out_destination;
    EditText out_money;
    EditText out_remarks;
    ImageButton out_confirm;
    View view=null;
    SharedPreferences pref;
    String result;

    public OutFragment() {

    }

    @Override
    public void onCreate(@Nullable Bundle savedInstanceState) {
        pref = PreferenceManager.getDefaultSharedPreferences(getContext());
        super.onCreate(savedInstanceState);

    }


    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        if(view==null) {
            view = inflater.inflate(R.layout.fragment_out1, container, false);
            pref = PreferenceManager.getDefaultSharedPreferences(getContext());
            user_name=(TextView)view.findViewById(R.id.out_userName);
            user_Tel=(TextView)view.findViewById(R.id.out_userTel);
            spinner_type =(Spinner)view.findViewById(R.id.out_type);
            spinner_type.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
                @Override
                public void onItemSelected(AdapterView<?> parent, View view, int position, long id) {
                    newOrder.setType(spinner_type.getSelectedItem().toString());
                }
                @Override
                public void onNothingSelected(AdapterView<?> parent) {
                    newOrder.setType("快递");

                }
            });
            out_time=(EditText) view.findViewById(R.id.out_aging);
            out_location=(EditText) view.findViewById(R.id.out_fromStation);
            out_destination=(EditText)view.findViewById(R.id.out_toStation);
            setToStation();
            out_money=(EditText) view.findViewById(R.id.out_reward);
            out_remarks=(EditText) view.findViewById(R.id.out_note);
            out_confirm=(ImageButton) view.findViewById(R.id.out_button);
            out_confirm.setOnClickListener(new View.OnClickListener(){
                @Override
                public void onClick(View v) {

                    if(TextUtils.isEmpty(out_time.getText())||TextUtils.isEmpty(out_location.getText())){
                        Toast.makeText(getActivity(),"订单信息还需要完善哦~",Toast.LENGTH_SHORT).show();

                    }else if (TextUtils.isEmpty(out_money.getText())){
                        Toast.makeText(getActivity(),"给钱好办事哦~",Toast.LENGTH_SHORT).show();
                    }
                    else {
                        Thread t = new Thread() {
                            public void run() {
                                newOrderInfo();
                                result = addOrder(newOrder);//传送order数据
                                Log.d("addOrder", result);
                            }
                        };
                        t.start();
                        while (t.isAlive()) {
                            ;
                        }
                        //result判断结果
                        if (result.equals("O_SUCCESS")) {
                            Toast.makeText(getActivity(), "add!", Toast.LENGTH_SHORT).show();
                            Intent intent = new Intent("com.example.addOrder");
                            getActivity().sendBroadcast(intent);

                        }
                    }
                }
            });
        }
            return view;
    }

    public void setToStation(){
        user_name.setText(pref.getString("userName","0"));
        user_Tel.setText(pref.getString("Tel","0"));
        String toStation=pref.getString("area","1")+pref.getString("buildingNumber","2");
        out_destination.setText(toStation);
    }

    //获得新订单信息
    public void newOrderInfo(){

        //newOrder.setOrderId();
        newOrder.setOrderManId(pref.getInt("userId",0));
        newOrder.setOrderManName(pref.getString("userName","sb"));
        newOrder.setAging(Integer.parseInt(out_time.getText().toString()));
        newOrder.setOrderFrom(out_location.getText().toString());
        newOrder.setOrderTo(out_destination.getText().toString());
        newOrder.setReward(Float.parseFloat(out_money.getText().toString()));
        if(TextUtils.isEmpty(out_remarks.getText())){
            newOrder.setNote("");
        }else {
            newOrder.setNote(out_remarks.getText().toString());
        }
        newOrder.setGetManId(0);


    }

    //订单信息传到服务端
    public static String addOrder(Home order){
        try {
            String path= UrlObject.url_path + "OrderOut";//url
            URL url=new URL(path);
            OkHttpClient client=new OkHttpClient();
            RequestBody requestBody=new FormBody.Builder()
                   // .add("orderId",String.valueOf(order.getOrderId()))
                    .add("orderManName",order.getOrderManName())
                    .add("orderManId",String.valueOf(order.getOrderManId()))
                    .add("type",order.getType())
                    .add("aging",String.valueOf(order.getAging()))
                    .add("fromStation",order.getOrderFrom())
                    .add("reward",String.valueOf(order.getReward()))
                    .add("toStation",order.getOrderTo())
                    .add("getManId",String.valueOf(order.getGetManId()))
                    //.add("orderStatus","1")
                    .add("note",order.getNote())
                    .build();
            Request request=new Request.Builder()
                    .url(url)
                    .post(requestBody)
                    .build();
            Response response=client.newCall(request).execute();
            String responseData=response.body().string();
            return responseData;



        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }


}
